function H = fixH(H,d3)
%  H = fixH(H)
%
%  Padding zeros if H is not odd sized
%  & make sure H is 3 x 3 cell arry for RGB images
%

if ~iscell(H)
    [ah,bh]  = size(H);
    if mod(ah,2) ~= 1
        H = [zeros(1,bh); H];
        ah = ah + 1;
    end
    if mod(bh,2) ~= 1
        H = [zeros(ah,1), H];
    end 
    
    if d3 == 3;
        h = cell(3,3);
        h{1,1} = H; h{2,2} = H; h{3,3} = H;
        H = h;
    end
else
    [nr,nc] = size(H);
    if nr == 1 && nc == 1
        h = cell(3,3);
        h{1,1} = H{1,1}; 
        h{2,2} = H{1,1}; 
        h{3,3} = H{1,1};
        H = h;
    elseif nr ~= 3 || nc ~= 3
        error('size of H is not correct!');
    end
    
    for ii = 1:3; 
        for jj = 1:3;
            if ~isempty(H{ii,jj})
                [ah,bh]  = size(H{ii,jj});
                if mod(ah,2) ~= 1
                    H{ii,jj} = [zeros(1,bh); H{ii,jj}];
                    ah = ah + 1;
                end
                if mod(bh,2) ~= 1
                    H{ii,jj} = [zeros(ah,1), H{ii,jj}];
                end
            else
                H{ii,jj} = 0;
            end
        end
    end
end



